# Logger Example

require 'logger'
require 'thread'

LOG = Logger.new(STDOUT)
LOG.level = Logger::INFO
flag = nil

if ARGV.length < 4 
	puts "Usage: ruby pingmapper.rb [XMIN] [XMAX] [YMIN] [YMAX] [-p|m]"
	puts "\tNo flag to bring up/config eth0 and to run ping and map"
	puts "\t-p to just ping"
	puts "\t-m to only map(interfaces must be configured)"	
	exit
end

XMIN = ARGV[0].to_i
XMAX = ARGV[1].to_i
YMIN = ARGV[2].to_i
YMAX = ARGV[3].to_i
flag = ARGV[4]

LOCK = Mutex.new()
buffer = Array.new()
sucess = Array.new()
threads = Array.new()

begin
	Range.new(XMIN,XMAX).map do |x|
		Range.new(YMIN,YMAX).map do |y|
			t = Thread.new do
				ssh_args = "-o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no"
				user = 'root'
				host="node#{x}-#{y}"

				ifconfig = "ifconfig eth0 inet 192.168.#{x}.#{y} up"
				cmd = "ping -c 1 -I eth0 -b 192.168.0.1"

				#grab just eth0 HW address 
				hwaddr = "ifconfig | grep HWaddr | awk '{split($0,a,\" \"); print a[5]}' | head -1"	

				if flag.nil?  
					`ssh #{ssh_args} #{user}@node#{x}-#{y} #{ifconfig} 1>/dev/null 2>/dev/null`
				end

				unless flag == "-m" 
				 	res = `ssh #{ssh_args} #{user}@node#{x}-#{y} #{cmd} 1>/dev/null 2>/dev/null`
				end
				
				unless flag == "-p"
					res = `ssh #{ssh_args} #{user}@node#{x}-#{y} #{hwaddr} 2>/dev/null`
				end

				buffer.push("#{x},#{y} = #{res}")
			
				LOG.debug("Results was: #{res.chomp} for #{x},#{y}")
				LOCK.synchronize {sucess.push([x,y]) unless res.nil?}

			end
			threads.push(t)
		 end
	 end
	threads.map{|t| t.join}
rescue => err
	LOG.fatal("Caught exception; exiting")
	LOG.fatal(err)
ensure
	LOG.debug("Sucessfull nodes:[#{sucess.map{|b|"[#{b[0]},#{b[1]}]"}.join(",")}]")
	LOG.debug("Number of sucesses: #{sucess.length}")
	puts buffer.sort
end

